<?php
require_once('HTML/QuickForm.php');
require_once('HTML/QuickForm/Rule.php');
require_once('HTML/QuickForm/Renderer/Array.php');
require_once('QFFastSmartyRenderer.class.php');
require_once('../../Smarty-2.6.9/libs/Smarty.class.php');

define('VALIDATION_SIDE', 'client');
//define('VALIDATION_SIDE', 'server');

$form =& new HTML_QuickForm('form_test', 'POST');

$form->setJsWarnings(
	'ιܤͤʤǽޤ.', 
	'ͤ٤ǧ'
	);

$form->setRequiredNote("ɬܹܤϤˤղ");

////////////////////////////////////////
//
// hidden Values
// constructor('hidden', name, value)
//

$form->addElement('hidden', 'hd1', 'hd1_val');
$form->addElement('hidden', 'hd2', 'hd2_val');

////////////////////////////////////////
//
// Headers (Section?)
// constructor('header', name, caption) // (No value, Virtual Element.)
//

$form->addElement('header', 'header1', 'header1_caption');

////////////////////////////////////////
//
// text box
// constructor('text', name, caption, html_tag_attributes)
//

$form->addElement('text', 'txt1', 'txt1_capt');

$tels = array();
$tels[] =& HTML_QuickForm::createElement('text', 'tel1', null,
	array('size' => 5, 'maxlength' => 4));
$tels[] =& HTML_QuickForm::createElement('text', 'tel2', null,
	array('size' => 5, 'maxlength' => 4));
$tels[] =& HTML_QuickForm::createElement('text', 'tel3', null,
	array('size' => 5, 'maxlength' => 4));
$form->addGroup($tels, 'tel', 'tel_capt', '-');

$zips = array();
$zips[] =& HTML_QuickForm::createElement('text', 'zip1', null,
	array('size' => 4, 'maxlength' => 3));
$zips[] =& HTML_QuickForm::createElement('text', 'zip2', null,
	array('size' => 5, 'maxlength' => 4));
$form->addGroup($zips, 'zip', 'zip_capt', '-');

/* setDefaults()ǥ롼פФͤꤹȤ
 * 'tel' => array('123', '456', '7890')
 * Τ褦ź̵ؼWarningȯޤ
 * ΤᡢElement̾ꤷƤΤ褦˳Element̾Ф
 * Ϣǥǥեͤꤹɬפޤ
 */
$form->setDefaults(array(
	'txt1' => 'sample',
	'tel' => array('tel1' => '0123', 'tel2' => '456', 'tel3' => '7890'),
	'zip' => array('zip1' => '123', 'zip2' => '4567')
	));

$form->addRule(
	'txt1', 
	'txt1ϤƤޤ', 
	'required', 
	null, 
	VALIDATION_SIDE);
/* addGroupξ硢addGroupRuleѤΤǤ
 * http://pear.php.net/manual/en/package.html.html-quickform.html-quickform.addgrouprule.php
 * 򻲾ȤƲ
 */
$form->addGroupRule(
	'tel', // Group Name
	'telϤƤޤ', // Array or String for one element
	'required', // rule type
	null, // rule option
	3, // validation element number
	VALIDATION_SIDE, // validation side
	true); // if true and validation side is 'client', restore default.

$form->addGroupRule('tel', 'telȾѿϤƲ', 'numeric', 
	null, 3, VALIDATION_SIDE, true);
$form->addGroupRule('zip', 'zipϤƤޤ', 'required', 
	null, 2, VALIDATION_SIDE, true);
$form->addGroupRule('zip', 'zipȾѿϤƲ', 'numeric', 
	null, 2, VALIDATION_SIDE, true);

////////////////////////////////////////
//
// select pulldown menu
// constructor('select', name, caption, options, html_tag_attributes)
// 

$options = array(
	'-1' => '-- Please Select --',
	'1' => 'item1',
	'2' => 'item2',
	'3' => 'item3',
	'4' => 'item4',
	'5' => 'item5');

$form->addElement('select', 'sel1', 'sel1_capt', $options);
$form->addElement('select', 'sel2', 'sel2_capt', $options);
$form->setDefaults(array(
	'sel2' => 3));

class RuleSelectRequired extends HTML_QuickForm_Rule
{
	function validate($value, $options = null)
	{
		if(is_array($options)) {
			for($i = 0; $i < count($options); $i++) {
				if($options[$i] == $value) return false;
			}
		} else {
			if($options == null) $options = -1;
			if($value == $options) return false;
		}
		return true;
	}
};

$form->registerRule('select_required', null, 'RuleSelectRequired');
$form->addRule(
	'sel1', 
	'ͭʥƥ򤷤Ƥ', 
	'select_required', 
	null);
$form->addRule(
	'sel2',
	'ͭʥƥ⡢item1, 3, 5ʳ򤷤Ƥ',
	'select_required',
	array(1, 3, 5));

////////////////////////////////////////
//
// check buttons
// constructor('checkbox', name, caption, lable, html_tag_attributes)
// note: checkbox value option can't be modified and set to 1.
//

$form->addElement('checkbox', 'cb1', 'cb1_capt', 'cb1_label', 
	array('checked' => 'checked'));
$form->addElement('checkbox', 'cb2', 'cb2_capt', 'cb2_label', 
	array('checked' => ''));

$checks = array();
$checks[] =& HTML_QuickForm::createElement(
	'checkbox', 'cb3_1', null, 'cb3_1_label');
$checks[] =& HTML_QuickForm::createElement(
	'checkbox', 'cb3_2', null, 'cb3_2_label');
$form->addGroup($checks, 'cb3', 'cb3_capt', "<br />\n");

$form->setDefaults(array(
	'cb1' => true,
	'cb2' => false,
	'cb3' => array('cb3_1' => true, 'cb3_2' => true)
	));

////////////////////////////////////////
//
// advcheckbox
// constructor('adbcheckbox', name, caption, label, html_tag_attributes, val)
//

$form->addElement('advcheckbox', 'acb1', 'acb1_capt', 'acb1_label', 
	array(), 'acb1_value');

$advchecks = array();
$advchecks[] =& HTML_QuickForm::createElement(
	'advcheckbox', 'acb2_1', null, 'acb2_1_label', array(), 'acb2_1_val');
$advchecks[] =& HTML_QuickForm::createElement(
	'advcheckbox', 'acb2_2', null, 'acb2_2_label', array(), 'acb2_1_val');
$advchecks[] =& HTML_QuickForm::createElement(
	'advcheckbox', 'acb2_3', null, 'acb2_3_label', array(), 'acb2_1_val');
$form->addGroup($advchecks, 'acb2', 'acb2_capt', "<br />\n");

$form->setDefaults(array(
	'acb1' => true,
	'acb2' => array('acb2_1' => true, 'acb2_2' => false, 'acb2_3' => true)));

////////////////////////////////////////
//
// radio buttons
// constructor('radio', name, caption, label, value, html_tag_attributes)
//

$form->addElement('radio', 'rb1', 'rb1_capt', 'rb1_label', 1, array());
$form->addElement('radio', 'rb2', 'rb2_capt', 'rb2_label', 2);

$radios = array();
$radios[] =& HTML_QuickForm::createElement(
	'radio', null, null, 'rb3_1_label', 31);
$radios[] =& HTML_QuickForm::createElement(
	'radio', null, null, 'rb3_2_label', 32);
$form->addGroup($radios, 'rb3', 'rb3_capt', "<br />\n");

$radios = array();
$radios[] =& HTML_QuickForm::createElement(
	'radio', null, null, 'rb4_1_label', 31);
$radios[] =& HTML_QuickForm::createElement(
	'radio', null, null, 'rb4_2_label', 32);
$form->addGroup($radios, 'rb4', 'rb4_capt', "<br />\n");

$form->setDefaults(array('rb3' => 32));

$form->addRule(
	'rb4',
	'rb4ɬɤ餫򤷤Ʋ',
	'required',
	null,
	VALIDATION_SIDE);
	

////////////////////////////////////////
//
// date form set
// constructor('date', name, caption, format)
//

$current = getdate(time());

$form->addElement('date', 'date1', 'date1_capt', 
	array(
		'format' => 'Y ǯ m  d  H  i ʬ s ', 
		'minYear' => date('Y', time()) - 10, 
		'maxYear' => date('Y', time()) + 10,
		'addEmptyOption' => true,
		'emptyOptionValue' => -1,
		'emptyOptionText' => '--',
		'optionIncrement' => array('i' => 1, 's' => 1)
//		'optionIncrement' => array('i' => 5, 's' => 10)
/* optionIncrementȤӤȤӤˤȡsetDefaults()Ǥgetdate
 * ͤ礦ɤȤӤȤӤ˥ޥåʤȥǥեȤȤƥåȤƤޤ
 * ΤդɬפǤ
 */
	));

$form->setDefaults(array('date1' => array(
	'Y' => $current['year'],
	'm' => $current['mon'],
	'd' => $current['mday'],
	'H' => $current['hours'],
	'i' => $current['minutes'],
	's' => $current['seconds'])));

/**
 * YmdϤ줿dateElementμ¸ǯåԤ
 *
 */
class RuleCheckDate extends HTML_QuickForm_Rule
{
	function validate($value, $options)
	{
		if(@checkdate(@$value['m'], @$value['d'], @$value['Y']))
			return true;
		else return false;
	}
};

$form->registerRule('checkdate', null, 'RuleCheckDate');
$form->addRule(
	'date1', 
	'date1Ǥϼºߤǯ򤷤Ʋ', 
	'checkdate', 
	null);

////////////////////////////////////////
//
// submit or reset buttons
// constructor('submit', name, value, html_tag_attributes)
// constructor('reset', name, value, html_tag_attributes)
//

$form->addElement('submit', 'submit_button', 'submit_value(label)');
$form->addElement('reset', 'reset_button', 'reset_value(label)');

////////////////////////////////////////
//
// Multiple Custom Form Rule
//

function customFormRule1($submitValues, $submitFiles)
{
//	var_dump($submitValues);
	$val1 = $submitValues['tel']['tel1'];
	$val2 = $submitValues['tel']['tel2'];
	$val3 = $submitValues['tel']['tel3'];
	if($val1 + $val2 + $val3 == 3000) {
		return true;
	} else {
		return array('tel' => 'telϹפ3000Ȥʤ褦ˤƲ');
	}
}

function customFormRule2($submitValues, $submitFiles)
{
//	var_dump($submitFiles);
	$val1 = $submitValues['zip']['zip1'];
	$val2 = $submitValues['zip']['zip2'];
	if($val1 + $val2 == 2000) {
		return true;
	} else {
		return array(
			'zip' => 'zipϹפ2000Ȥʤ褦ˤƲ',
			'txt1' => '(ϥߡΥ顼Ǥ)',
			);
	}
}

$form->addFormRule('customFormRule1');
$form->addFormRule('customFormRule2');

////////////////////////////////////////
//
// Invoking QuickForm
//

// Tries to validate the form
if ($form->validate()) {
    // Form is validated, then processes the data
    $form->freeze();
    $form->process('myProcess', false);
    var_dump($form->exportValues());
    echo "\n<HR>\n";
}

// Process callback
function myProcess($values)
{
    echo '<pre>';
    var_dump($values);
    echo '</pre>';
}

/*
$renderer =& new HTML_QuickForm_Renderer_Array();
$form->accept($renderer);
var_dump($renderer->toArray());
*/

$smarty =& new Smarty;
$smarty->left_delimiter = '<{';
$smarty->right_delimiter = '}>';
$smarty->compile_dir = "./";
$renderer =& new QFFastSmartyRenderer($smarty, true);
$form->accept($renderer);
$smarty->assign('form', $renderer->toArray());
$smarty->assign('rules', $form->getRegisteredRules());
$smarty->display(realpath("./test01_tpl.html"));

//var_dump($renderer->toArray());
var_dump($_ENV);
print(isset($_ENV['OS']) && preg_match("/window/i", $_ENV['OS']));


?>
